this.name			= "demand_driven_economy";
this.author			= "Redspear";
this.copyright		= "2021 Redspear";
this.licence		= "CC BY-NC-SA 4.0"; 
this.description	= "Import demand by economy type";
this.version		= "1.2";

"use strict";

this.guiScreenChanged = function ()	//	a little in game clue/reminder for the player

{
    if (guiScreen === "GUI_SCREEN_SYSTEM_DATA") {
		
        if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 0) {	// rich industrial
                mission.addMessageText("Highly successful industrial systems are home to many wealthy citizens. Ostentatious displays of that wealth are not uncommon.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 1) {	//	average industrial
                mission.addMessageText("Here bars of all kinds serve to distract the typical citizen from the daily grind of industrialised work.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 2) {	//	poor industrial
                mission.addMessageText("Great fabric mills work endlessly here - subject to adequate supply of course.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 3) {	//	mainly industrial
                mission.addMessageText("Nuclear reactors are still the typical means of power generation on mainly industrial worlds.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 4) {	//	mainly agricultural
                mission.addMessageText("Increasing automation is typically a goal of such an economy.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 5) {	//	rich agricultural
                mission.addMessageText("Affluent rural worlds are often beautiful but sometimes lack the finer components of urban convenience.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 6) {	//	average agricultural
                mission.addMessageText("Growing production economies typcally have good infrastructure but lack optimisation.");
		}
		if (System.infoForSystem(galaxyNumber, player.ship.targetSystem).economy === 7) {	//	poor agricultural
                mission.addMessageText("Agricultural systems that are still trying to establish themselves often require basic structural components.");
		}
	}
}

this.shipExitedWitchspace = function()	// arrival and setting the markets

{
    if (system.isInterstellarSpace) return;	// no conventional market and no economy type... let's not bother
	
	//	player.ship.fuel = 7.0;	//	test code so I/you can zip about and see if this thing is actually working...

    var demand_mod = (system.population - 35); // price adjustment for imports
    var supply_mod = 28 - (system.productivity / 1000); // supply adjustment for exports
	var focus_mod = (system.techLevel - 8) * 2; // price adjustment for exports
	var new_stock; // stocking variation
	var new_price; // price variation
	var shortage_factor; //	where there's high demand there's low supply

	
	if(system.economy == 0)     // rich industrial
        {
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("luxuries", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("computers", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("machinery", new_stock); 
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("alloys", new_stock); 
		
		new_price = Math.floor(system.mainStation.market.luxuries.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(system.mainStation.market.computers.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(system.mainStation.market.machinery.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("machinery", new_price); 
		new_price = Math.floor(system.mainStation.market.alloys.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price);  
		
		new_price = Math.floor(560 + 144 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(252 + 80 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(212 + 48 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(64 + 32 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.textiles.quantity / 1.5);
		system.mainStation.setMarketQuantity("textiles", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.radioactives.quantity / 3);
		system.mainStation.setMarketQuantity("radioactives", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.liquor_wines.quantity / 6);
		system.mainStation.setMarketQuantity("liquor_wines", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.furs.quantity / 12);
		system.mainStation.setMarketQuantity("furs", shortage_factor);
        }
        
	if(system.economy == 1)     // average industrial
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("luxuries", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("computers", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("machinery", new_stock); 
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("alloys", new_stock); 

		new_price = Math.floor(system.mainStation.market.luxuries.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(system.mainStation.market.computers.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(system.mainStation.market.machinery.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("machinery", new_price); 
		new_price = Math.floor(system.mainStation.market.alloys.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price);  
		
		new_price = Math.floor(560 + 60 + ((Math.random() * (20 - 1 + 1)) * 4));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(252 + 107 + ((Math.random() * (20 - 1 + 1)) * 3));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(212 + 36 + ((Math.random() * (20 - 1 + 1)) * 2));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(64 + 24 + (Math.random() * (20 - 1 + 1)));
		system.mainStation.setMarketPrice("textiles", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.textiles.quantity / 1.5);
		system.mainStation.setMarketQuantity("textiles", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.radioactives.quantity / 3);
		system.mainStation.setMarketQuantity("radioactives", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.furs.quantity / 6);
		system.mainStation.setMarketQuantity("furs", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.liquor_wines.quantity / 12);
		system.mainStation.setMarketQuantity("liquor_wines", shortage_factor);
        }
        

	if(system.economy == 2)     // poor industrial
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("luxuries", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("computers", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("machinery", new_stock); 
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("alloys", new_stock); 
		
		new_price = Math.floor(system.mainStation.market.luxuries.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(system.mainStation.market.computers.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(system.mainStation.market.machinery.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("machinery", new_price); 
		new_price = Math.floor(system.mainStation.market.alloys.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price);  
		
		new_price = Math.floor(560 + 7 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(252 + 11 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(212 + 20 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(64 + 37 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5)));
		system.mainStation.setMarketPrice("textiles", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.furs.quantity / 1.5);
		system.mainStation.setMarketQuantity("furs", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.liquor_wines.quantity / 3);
		system.mainStation.setMarketQuantity("liquor_wines", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.radioactives.quantity / 6);
		system.mainStation.setMarketQuantity("radioactives", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.textiles.quantity / 12);
		system.mainStation.setMarketQuantity("textiles", shortage_factor);
        }
        

	if(system.economy == 3)     // mainly industrial
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("luxuries", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("computers", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("machinery", new_stock); 
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("alloys", new_stock);  
		
		new_price = Math.floor(system.mainStation.market.luxuries.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(system.mainStation.market.computers.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(system.mainStation.market.machinery.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("machinery", new_price); 
		new_price = Math.floor(system.mainStation.market.alloys.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price);   
		
		new_price = Math.floor(560 + 15 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(252 + 40 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(212 + 72 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(64 + 23 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.furs.quantity / 1.5);
		system.mainStation.setMarketQuantity("furs", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.textiles.quantity / 3);
		system.mainStation.setMarketQuantity("textiles", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.liquor_wines.quantity / 6);
		system.mainStation.setMarketQuantity("liquor_wines", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.radioactives.quantity / 12);
		system.mainStation.setMarketQuantity("radioactives", shortage_factor);
        }
        

	if(system.economy == 4)     // mainly agricultural
        {
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("furs", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("liquor_wines", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("radioactives", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 20) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("textiles", new_stock); 
		
		new_price = Math.floor(system.mainStation.market.furs.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(system.mainStation.market.liquor_wines.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(system.mainStation.market.radioactives.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(system.mainStation.market.textiles.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price);  
		
		new_price = Math.floor(912 + 7 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(840 + 62 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(560 + 112 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("machinery", new_price);
		new_price = Math.floor(328 + 47 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.luxuries.quantity / 1.5);
		system.mainStation.setMarketQuantity("luxuries", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.alloys.quantity / 3);
		system.mainStation.setMarketQuantity("alloys", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.computers.quantity / 6);
		system.mainStation.setMarketQuantity("computers", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.machinery.quantity / 12);
		system.mainStation.setMarketQuantity("machinery", shortage_factor);
        }
        

	if(system.economy == 5)     // rich agricultural
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("furs", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("liquor_wines", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("radioactives", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 60) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("textiles", new_stock);  
		
		new_price = Math.floor(system.mainStation.market.furs.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(system.mainStation.market.liquor_wines.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(system.mainStation.market.radioactives.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(system.mainStation.market.textiles.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price);  
		
		new_price = Math.floor(912 + 222 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(840 + 127 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(560 + 97 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("machinery", new_price);
		new_price = Math.floor(328 + 16 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.alloys.quantity / 1.5);
		system.mainStation.setMarketQuantity("alloys", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.machinery.quantity / 3);
		system.mainStation.setMarketQuantity("machinery", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.computers.quantity / 6);
		system.mainStation.setMarketQuantity("computers", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.luxuries.quantity / 12);
		system.mainStation.setMarketQuantity("luxuries", shortage_factor);
        }
        

	if(system.economy == 6)     // average agricultural
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("furs", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("liquor_wines", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("radioactives", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 40) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("textiles", new_stock);  
		
		new_price = Math.floor(system.mainStation.market.furs.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(system.mainStation.market.liquor_wines.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(system.mainStation.market.radioactives.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(system.mainStation.market.textiles.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price);  
		
		new_price = Math.floor(912 + 95 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(840 + 167 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(560 + 72 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("machinery", new_price);
		new_price = Math.floor(328 + 11 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.alloys.quantity / 1.5);
		system.mainStation.setMarketQuantity("alloys", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.machinery.quantity / 3);
		system.mainStation.setMarketQuantity("machinery", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.luxuries.quantity / 6);
		system.mainStation.setMarketQuantity("luxuries", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.computers.quantity / 12);
		system.mainStation.setMarketQuantity("computers", shortage_factor);
        }
        

	if(system.economy == 7)     // poor agricultural
        {
        new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);	
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("furs", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("liquor_wines", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
        system.mainStation.setMarketQuantity("radioactives", new_stock);
		new_stock = Math.floor(((Math.random() + 0.5) * 30) - supply_mod);
		if(new_stock < 0) {new_stock = 0};
		system.mainStation.setMarketQuantity("textiles", new_stock); 
		
		new_price = Math.floor(system.mainStation.market.furs.price + (focus_mod * 4) + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("furs", new_price);
		new_price = Math.floor(system.mainStation.market.liquor_wines.price - (focus_mod * 3) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("liquor_wines", new_price);
		new_price = Math.floor(system.mainStation.market.radioactives.price - (focus_mod * 2) + (Math.random() * (10 - 1 + 1) - 5));
        system.mainStation.setMarketPrice("radioactives", new_price); 
		new_price = Math.floor(system.mainStation.market.textiles.price + focus_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("textiles", new_price);  
		
		new_price = Math.floor(912 + 3 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 4));
		system.mainStation.setMarketPrice("luxuries", new_price);
		new_price = Math.floor(840 + 23 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 3));
        system.mainStation.setMarketPrice("computers", new_price);
		new_price = Math.floor(560 + 32 + demand_mod + ((Math.random() * (10 - 1 + 1) - 5) * 2));
        system.mainStation.setMarketPrice("machinery", new_price);
		new_price = Math.floor(328 + 55 + demand_mod + (Math.random() * (10 - 1 + 1) - 5));
		system.mainStation.setMarketPrice("alloys", new_price); 
		
		shortage_factor = Math.floor(system.mainStation.market.luxuries.quantity / 1.5);
		system.mainStation.setMarketQuantity("luxuries", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.computers.quantity / 3);
		system.mainStation.setMarketQuantity("computers", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.machinery.quantity / 6);
		system.mainStation.setMarketQuantity("machinery", shortage_factor);
		shortage_factor = Math.floor(system.mainStation.market.alloys.quantity / 12);
		system.mainStation.setMarketQuantity("alloys", shortage_factor);
        }

}